import greenfoot.*;

public class MyWorld extends World {

    private boolean[][] raster;
    private boolean[][] wirdLebendigSein;
    private int weite = 400;
    private int hoehe = 400;

    private boolean istWechsel = false;

    public MyWorld() {    
        super(400, 400, 1); 
        raster = new boolean[weite][hoehe];
        wirdLebendigSein = new boolean[weite][hoehe];

        for (int i=0; i<weite; i++) {
            for (int j=0; j<hoehe; j++) {
                raster[i][j] = false;
                wirdLebendigSein[i][j] = false;
            }
        }

        // Muster:
        erzeugeMuster03();
    }

    private void erzeugeMuster03() {
        for (int i=0; i<48000; i++) {
            int x = Greenfoot.getRandomNumber(weite);
            int y = Greenfoot.getRandomNumber(hoehe);
            raster[x][y] = true;
            getBackground().setColorAt(x, y, Color.BLACK);
        }
    }

    private int gibAnzahlLebenderNachbarn(int x, int y) {
        int help = 0;
        if ( (x>0) && (x<weite-1) && (y>0) && (y<hoehe-1) ) {
            if (raster[x-1][y-1] == true) {
                help++;
            }
            if (raster[x][y-1] == true) {
                help++;
            }
            if (raster[x+1][y-1] == true) {
                help++;
            }
            if (raster[x-1][y] == true) {
                help++;
            }
            if (raster[x+1][y] == true) {
                help++;
            }
            if (raster[x-1][y+1] == true) {
                help++;
            }
            if (raster[x][y+1] == true) {
                help++;
            }
            if (raster[x+1][y+1] == true) {
                help++;
            }
        }
        return help;
    }

    public void act() {

        for (int i=0; i<weite; i++) {

            for (int j=0; j<hoehe; j++) {

                if (istWechsel == true)
                {
                    if (wirdLebendigSein[i][j] == true)
                    {
                        raster[i][j] = true;
                        getBackground().setColorAt(i, j, Color.BLACK);
                    }
                    else
                    {
                        raster[i][j] = false;
                        getBackground().setColorAt(i, j, Color.WHITE);
                    }
                }
                else
                {

                    if ( (raster[i][j] == false) && (gibAnzahlLebenderNachbarn(i,j) == 3) )
                    {
                        wirdLebendigSein[i][j] = true;
                    }

                    if ( (raster[i][j] == true) && (gibAnzahlLebenderNachbarn(i,j) < 2) )
                    {
                        wirdLebendigSein[i][j] = false;
                    }

                    if ( (raster[i][j] == true) && ((gibAnzahlLebenderNachbarn(i,j) == 2) || (gibAnzahlLebenderNachbarn(i,j) == 3) ) )
                    {
                        wirdLebendigSein[i][j] = true;
                    }

                    if ( (raster[i][j] == true) && (gibAnzahlLebenderNachbarn(i,j) > 3) )
                    {
                        wirdLebendigSein[i][j] = false;
                    }
                }

            }
        }
        istWechsel = !istWechsel;
    }
}
