import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList; // Listen importieren

public class Hai extends Tier {

    // Attribute
    private int SHARK_BREED = 1;
    private int SHARK_STARVE = 0;
    private int energy;

    /**
     * Konstruktor:
     * jeder Hai wird mit energy 0 erzeugt
     */
    public Hai() {
        energy = 0;
    }   

    /**
     * ACT - Ablauf:
     * 
     * 1. bewegen: entweder auf ein Nachbarfeld mit Fisch gehen, diesen
     *    essen und Energie dazugewinnen oder auf ein freies Nachbarfeld gehen
     * 2. wenn genug Energie, dann Nachkomme erzeugen
     * 3. ggf sterben bei zu wenig Energie
     * 4. Energie verringern
     */
    public void act() {
        // Bewegen:
        // falls es ein Nachbarfeld mit Fisch gibt: dahin gehen und Fisch fressen
        // falls nicht: auf ein zufälliges leeres Feld gehen
        Koordinate k = getNachbarfeldMitFisch();
        if (k != null) {
            setLocation(k.getX(), k.getY());
            Fisch f = (Fisch)getOneObjectAtOffset(0,0,Fisch.class);
            if (f != null) {// dürfte ja nicht sein
                getWorld().removeObject(f); // Fisch fressen und entfernen
                energy++; // Erhöhen der Energie
            }
        }
        else {
            k = getZufaelligesFreiesNachbarfeld();
            if (k != null) {
                setLocation(k.getX(), k.getY());
            }
        }        

        // ggf. Nachkomme erzeugen
        if (energy >= SHARK_BREED) {
            Hai h = new Hai();
            erzeugeNachkomme(h);
        }

        // ggf. sterben
        if (energy == SHARK_STARVE) {
            getWorld().removeObject(this);
        }

        // Energie verringern
        energy--; 
    }    
}
